/*
 * Created on 02.09.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package TUGLaby;

/**
 * @author user
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TuringFieldAndState {

    public static final int RIGHT = 1;
    public static final int DOWN = 2;
    public static final int LEFT = 3;
    public static final int UP = 4;
    
    public static final char ERROR_CHAR = '$';
    
    private char[][] current_labyrinth_;  // 0..(SIZE-1)
    private int labyrinth_height_;
    private int labyrinth_width_;
    
    private char start_symbol_;
    private char wall_symbol_;
    private char diamond_symbol_;
    private char gallery_symbol_;
    private char worm_symbol_;
    private char marker_symbol_; // !
    
    private int start_direction_; // 1=RIGHT 2=DOWN 3=LEFT 4=UP
    private int current_x_;
    private int current_y_;
    
    private int current_direction_;
    private int count_diamonds_;
    
    /**
     * 
     */
    public TuringFieldAndState() {
        
        // FIXXXME START HARDCODED INIT
        String test_lab = "WWWWWWWWWWS...W..D.WWWW.W.WWWWW...W....WW.WWWWW..WW.W~W....WW.....D..WWWWW.....WWD...WWDWWWWWWWWWWWW";
        labyrinth_width_ = 10;
        labyrinth_height_ = 10;
        current_labyrinth_ = new char[labyrinth_height_][labyrinth_width_];

        for (int i = 0; i < 10; i++)
            for (int j = 0; j < 10; j++)
                current_labyrinth_[i][j] = test_lab.charAt(j + (i * 10));
        start_symbol_ = 'S';
        wall_symbol_ = 'W';
        diamond_symbol_ = '*';
        gallery_symbol_ = '.';
        worm_symbol_ = '~';
        start_direction_ = RIGHT;
        current_x_ = 0;
        current_y_ = 1;
        // FIXXXME END HARDCODED INIT
        
        current_direction_ = start_direction_;
        count_diamonds_ = countDiamonds();
    }
    
    private int countDiamonds()
    {
       int count = 0;
        for (int i = 0; i < 10; i++)
            for (int j = 0; j < 10; j++)
            {
              if( current_labyrinth_[i][j] == diamond_symbol_ )
                  count++;
            }    
       return count; 
    }
    
    /**
     * this methode returns the corresponding symbol
     * depending on the current viewingdirection and the parameter
     * it represents the sensors of the roboter
     *
     * @param direction  -1 = Left Field, 0 = Ahead Field, 1 = Right Field
     * @return the symbol @ the given position else ERROR_CHAR
     */
    // modify access
    public char getSymbolByDirection( int direction )
    {
       int absolute_direction = ( current_direction_ + direction ) % 4;
       if( absolute_direction == 0 )
           absolute_direction = UP;

       switch( absolute_direction ) {
           case UP    : 
           {
               if( (current_y_-1) < 0 )
                   return ERROR_CHAR;
               else
                   return current_labyrinth_[current_y_-1][current_x_];
       
           }
           case DOWN    : 
           {
               if( (current_y_+1) > (labyrinth_height_-1) )
                   return ERROR_CHAR;
               else
                   return current_labyrinth_[current_y_+1][current_x_];
       
           }   
           case LEFT    : 
           {
               if( (current_x_-1) < 0 )
                   return ERROR_CHAR;
               else
                   return current_labyrinth_[current_y_][current_x_-1];
       
           }
           case RIGHT    : 
           {
               if( (current_x_+1) > (labyrinth_width_-1) )
                   return ERROR_CHAR;
               else
                   return current_labyrinth_[current_y_][current_x_+1];
       
           }
       }
       return ERROR_CHAR;
    }
    
    public char getSymbolAtCurrentPosition()
    {
        return current_labyrinth_[current_y_][current_x_];
    }
    
    public void setSymboldAtCurrentPosition( char new_symbol )
    {
        current_labyrinth_[current_y_][current_x_] = new_symbol; 
    }
    /**
     * @return Returns the diamond_symbol_.
     */
    public char getDiamondSymbol() {
        return diamond_symbol_;
    }
    /**
     * @param diamond_symbol_ The diamond_symbol_ to set.
     */
    public void setDiamondSymbol(char diamond_symbol) {
        this.diamond_symbol_ = diamond_symbol;
    }
    /**
     * @return Returns the gallery_symbol_.
     */
    public char getGallerySymbol() {
        return gallery_symbol_;
    }
    /**
     * @param gallery_symbol_ The gallery_symbol_ to set.
     */
    public void setGallerySymbol(char gallery_symbol) {
        this.gallery_symbol_ = gallery_symbol;
    }
    /**
     * @return Returns the labyrinth_height_.
     */
    public int getLabyrinthHeight() {
        return labyrinth_height_;
    }
    /**
     * @param labyrinth_height_ The labyrinth_height_ to set.
     */
    public void setLabyrinthHeight(int labyrinth_height) {
        this.labyrinth_height_ = labyrinth_height;
    }
    /**
     * @return Returns the labyrinth_width_.
     */
    public int getLabyrinthWidth() {
        return labyrinth_width_;
    }
    /**
     * @param labyrinth_width_ The labyrinth_width_ to set.
     */
    public void setLabyrinthWidth(int labyrinth_width) {
        this.labyrinth_width_ = labyrinth_width;
    }
    /**
     * @return Returns the marker_symbol_.
     */
    public char getMarkerSymbol() {
        return marker_symbol_;
    }
    /**
     * @param marker_symbol_ The marker_symbol_ to set.
     */
    public void setMarkerSymbol(char marker_symbol) {
        this.marker_symbol_ = marker_symbol;
    }
    /**
     * @return Returns the start_direction_.
     */
    public int getStartDirection() {
        return start_direction_;
    }
    /**
     * @param start_direction_ The start_direction_ to set.
     */
    public void setStartDirection(int start_direction) {
        this.start_direction_ = start_direction;
    }
    /**
     * @return Returns the start_symbol_.
     */
    public char getStartSymbol() {
        return start_symbol_;
    }
    /**
     * @param start_symbol_ The start_symbol_ to set.
     */
    public void setStartSymbol(char start_symbol) {
        this.start_symbol_ = start_symbol;
    }
    /**
     * @return Returns the wall_symbol_.
     */
    public char getWallSymbol() {
        return wall_symbol_;
    }
    /**
     * @param wall_symbol_ The wall_symbol_ to set.
     */
    public void setWallSymbol(char wall_symbol) {
        this.wall_symbol_ = wall_symbol;
    }
    /**
     * @return Returns the worm_symbol_.
     */
    public char getWormSymbol() {
        return worm_symbol_;
    }
    /**
     * @param worm_symbol_ The worm_symbol_ to set.
     */
    public void setWormSymbol(char worm_symbol) {
        this.worm_symbol_ = worm_symbol;
    }
    /**
     * @return Returns the current_labyrinth_.
     */
    public void printCurrentLabyrinth() {
         for (int i = 0; i < 10; i++) {
             for (int j = 0; j < 10; j++)
                System.out.print(current_labyrinth_[i][j]) ;
           System.out.println();
         }  
    }
}
